PCLPainter (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.render.pcl

## Class PCLPainter

- java.lang.Object
- - org.apache.fop.render.intermediate.AbstractIFPainter<PCLDocumentHandler>
  - - org.apache.fop.render.pcl.PCLPainter

- All Implemented Interfaces:
    IFPainter

      public class PCLPainter
      extends AbstractIFPainter<PCLDocumentHandler>

  `IFPainter` implementation that produces PCL 5.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Object` | `COLOR_CANVAS` Enables/Disables a color canvas for bitmap production (required for SVG, for example)
    `static Object` | `DISABLE_CLIPPING` Disable clipping
    `static org.apache.xmlgraphics.util.QName` | `SRC_TRANSPARENCY` Source transparency mode

    - ### Fields inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `INSTREAM_OBJECT_URI, state`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PCLPainter(PCLDocumentHandler parent, PCLPageDefinition pageDefinition)` Main constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clipBackground(Rectangle rect, BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)` Restricts the current clipping region to the inner border.
    `void` | `clipRect(Rectangle rect)` Restricts the current clipping region with the given rectangle.
    `protected RenderingContext` | `createRenderingContext()` Creates a new RenderingContext instance.
    `void` | `drawBorderRect(Rectangle rect, BorderProps top, BorderProps bottom, BorderProps left, BorderProps right)`
    `void` | `drawImage(Document doc, Rectangle rect)` Draws an image (represented by a DOM document) inside a given rectangle.
    `void` | `drawImage(String uri, Rectangle rect)` Draws an image identified by a URI inside a given rectangle.
    `void` | `drawLine(Point start, Point end, int width, Color color, RuleStyle style)` Draws a line.
    `void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[][] dp, String text)` Draws text.
    `void` | `endGroup()` Ends the current group and restores the previous coordinate system (and layer).
    `void` | `endViewport()` Ends the current viewport and restores the previous coordinate system.
    `void` | `fillRect(Rectangle rect, Paint fill)` Fills a rectangular area.
    `protected int` | `getResolution()`
    `void` | `startGroup(AffineTransform transform, String layer)` Starts a new group of graphical elements.
    `void` | `startViewport(AffineTransform transform, Dimension size, Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.

    - ### Methods inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `createDefaultImageProcessingHints, drawBorderRect, drawImage, drawImage, drawImageUsingDocument, drawImageUsingImageHandler, drawImageUsingURI, drawSVGText, drawText, getContext, getDocumentHandler, getFontInfo, getFontKey, getImageForSupportedFlavors, getImageInfo, getLineBoundingBox, getUserAgent, hasOnlySolidBorders, isBackgroundRequired, setFont, startGroup, startViewport, toPoints`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SRC_TRANSPARENCY

          public static final org.apache.xmlgraphics.util.QName SRC_TRANSPARENCY

      Source transparency mode

    - #### DISABLE_CLIPPING

          public static final Object DISABLE_CLIPPING

      Disable clipping

    - #### COLOR_CANVAS

          public static final Object COLOR_CANVAS

      Enables/Disables a color canvas for bitmap production (required for SVG, for example)

  - ### Constructor Detail

    - #### PCLPainter

          public PCLPainter(PCLDocumentHandler parent,
                            PCLPageDefinition pageDefinition)

      Main constructor.
      Parameters:
        `parent` - the parent document handler
        `pageDefinition` - the page definition describing the page to be rendered

  - ### Method Detail

    - #### getResolution

          protected int getResolution()

      Returns:
        the target resolution

    - #### startViewport

          public void startViewport(AffineTransform transform,
                                    Dimension size,
                                    Rectangle clipRect)
                             throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Specified by:
        `startViewport` in interface `IFPainter`
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endViewport

          public void endViewport()
                           throws IFException

      Ends the current viewport and restores the previous coordinate system.
      Specified by:
        `endViewport` in interface `IFPainter`
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          public void startGroup(AffineTransform transform,
                                 String layer)
                          throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Specified by:
        `startGroup` in interface `IFPainter`
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endGroup

          public void endGroup()
                        throws IFException

      Ends the current group and restores the previous coordinate system (and layer).
      Specified by:
        `endGroup` in interface `IFPainter`
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### drawImage

          public void drawImage(String uri,
                                Rectangle rect)
                         throws IFException

      Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.
      Specified by:
        `drawImage` in interface `IFPainter`
      Parameters:
        `uri` - the image's URI
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### createRenderingContext

          protected RenderingContext createRenderingContext()

      Creates a new RenderingContext instance.
      Specified by:
        `createRenderingContext` in class `AbstractIFPainter<PCLDocumentHandler>`
      Returns:
        the new rendering context.

    - #### drawImage

          public void drawImage(Document doc,
                                Rectangle rect)
                         throws IFException

      Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.
      Specified by:
        `drawImage` in interface `IFPainter`
      Parameters:
        `doc` - the DOM document containing the foreign object
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipRect

          public void clipRect(Rectangle rect)
                        throws IFException

      Restricts the current clipping region with the given rectangle.
      Specified by:
        `clipRect` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipBackground

          public void clipBackground(Rectangle rect,
                                     BorderProps bpsBefore,
                                     BorderProps bpsAfter,
                                     BorderProps bpsStart,
                                     BorderProps bpsEnd)
                              throws IFException

      Restricts the current clipping region to the inner border.
      Specified by:
        `clipBackground` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `bpsBefore` - the border segment on the before-side (top)
        `bpsAfter` - the border segment on the after-side (bottom)
        `bpsStart` - the border segment on the start-side (left)
        `bpsEnd` - the border segment on the end-side (right)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### fillRect

          public void fillRect(Rectangle rect,
                               Paint fill)
                        throws IFException

      Fills a rectangular area.
      Specified by:
        `fillRect` in interface `IFPainter`
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `fill` - the fill paint
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawBorderRect

          public void drawBorderRect(Rectangle rect,
                                     BorderProps top,
                                     BorderProps bottom,
                                     BorderProps left,
                                     BorderProps right)
                              throws IFException

      Throws:
        `IFException`

    - #### drawLine

          public void drawLine(Point start,
                               Point end,
                               int width,
                               Color color,
                               RuleStyle style)
                        throws IFException

      Draws a line. NOTE: Currently, only horizontal lines are implemented!
      Specified by:
        `drawLine` in interface `IFPainter`
      Overrides:
        `drawLine` in class `AbstractIFPainter<PCLDocumentHandler>`
      Parameters:
        `start` - the start point of the line
        `end` - the end point of the line
        `width` - the line width
        `color` - the line color
        `style` - the line style (using the Constants.EN_* constants for the rule-style property)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawText

          public void drawText(int x,
                               int y,
                               int letterSpacing,
                               int wordSpacing,
                               int[][] dp,
                               String text)
                        throws IFException

      Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).
      Specified by:
        `drawText` in interface `IFPainter`
      Parameters:
        `x` - X-coordinate of the starting point of the text
        `y` - Y-coordinate of the starting point of the text
        `letterSpacing` - additional spacing between characters (may be 0)
        `wordSpacing` - additional spacing between words (may be 0)
        `dp` - an array of 4-tuples, expressing [X,Y] placment adjustments and [X,Y] advancement adjustments, in that order (may be null); if not null, then adjustments.length must be the same as text.length()
        `text` - the text
      Throws:
        `IFException` - if an error occurs while handling this event

Copyright © 2025 Apache Software Foundation. All rights reserved.